import { PackageConfig, defaultAuditThresholds } from '@genesislcap/foundation-testing/e2e';
import type { Locator, Page } from '@playwright/test';
import { playAudit } from 'playwright-lighthouse';

export class EntityManagementPage {
  config: PackageConfig;
  port: number;
  page: Page;
  entityList: Locator;

  constructor(config: PackageConfig, port: number, page: Page) {
    this.config = config;
    this.port = port;
    this.page = page;
    /**
     * Locate fields not guarded by conditionals upfront, and the remaining on-demand
     */
    this.entityList = this.page.locator('data-test-id=entity-list');
  }

  async goto() {
    await this.page.goto('/');
  }

  async audit() {
    await playAudit({
      page: this.page,
      port: this.port,
      thresholds: defaultAuditThresholds, // TODO: this should be coming from foundation-testing/src/playwright/test.ts base config
    });
  }
}
